<?php 
function qcilist_pro_modal_chart() {

?>
<div class="ilist-chart-field-modal" id="ilist-chart-field-modal" style="display:none">
  <div class="ilist-chart-field-modal-close">&times;</div>
  <h1 class="ilist-chart-field-modal-title"><?php esc_html_e( 'Create Chart' , 'qc-opd' ); ?></h1>
 <div style="position: absolute;right: 59px;">
<input type="button" value="<?php esc_html_e( 'Generate Chart' , 'qc-opd' ); ?>" class="button button-primary button-large getallvalue" />
</div>
  <div class="ilist-chart-field-modal-icons">

		<div class="form-group">
			<label for="charttype"><?php esc_html_e( 'Select Chart Type' , 'qc-opd' ); ?></label>

			<select id="charttype" class="form-control">
				<option value="line"><?php esc_html_e( 'Line' , 'qc-opd' ); ?></option>
				<option value="bar"><?php esc_html_e( 'Bar' , 'qc-opd' ); ?></option>
				<option value="radar"><?php esc_html_e( 'Radar' , 'qc-opd' ); ?></option>
				<option value="polarArea"><?php esc_html_e( 'Polar Area' , 'qc-opd' ); ?></option>
				<option value="pie"><?php esc_html_e( 'Pie' , 'qc-opd' ); ?></option>
				<option value="doughnut"><?php esc_html_e( 'Doughnut' , 'qc-opd' ); ?></option>
				
			</select>
		</div>
		<div class="form-group">
			<label for="datasettitle"><?php esc_html_e( 'Chart Title' , 'qc-opd' ); ?></label>
			<input type="text" id="charttitle" required/>
		</div>
		<div id="datasetcontainer" class="datasetcontainer">
			<p class="datasetheading"><?php esc_html_e( 'Dataset Area' , 'qc-opd' ); ?></p>
			<div class="form-group">
				<label for="datasettitle"><?php esc_html_e( 'Dataset Name' , 'qc-opd' ); ?></label>
				<input type="text" id="datasetname" required/>
			</div>
			<table id="datasettable" class="datasettable" cellspacing="0">
				<thead>
				<tr>
						<th class="manage-column column-cb check-column" scope="col"><?php esc_html_e( 'Label' , 'qc-opd' ); ?></th> 
						<th id="columnname" class="manage-column column-columnname" scope="col"><?php esc_html_e( 'Value' , 'qc-opd' ); ?></th>
						<th id="columnname" class="manage-column column-columnname" scope="col"><?php esc_html_e( 'Color' , 'qc-opd' ); ?></th>
				</tr>
				</thead>
				<tfoot>
					<tr>
						<th class="manage-column column-cb check-column" scope="col"><input type="button" id="chartaddrow" value="+ <?php esc_html_e( 'Add row' , 'qc-opd' ); ?>" class="button button-primary button-large" /></th>
						<th class="manage-column column-columnname" scope="col"></th>
					</tr>
				</tfoot>
				<tbody>
					<tr>
						<td class="check-column" scope="row"><input type="text" name="label[]" /></td>
						<td class="column-columnname"><input type="number" name="value[]" /></td>
						<td class="column-columnname"><input type="text" name="bgcolor[]" class="color-field" /></td>
						
						<td class="column-columnname"><a href="javascript:void(0);" class="button button-secondary removerow"><?php esc_html_e( 'Remove' , 'qc-opd' ); ?></a></td>
					</tr>
				</tbody>
			</table>
			
		</div>
		<div id="configurationcontainer" class="configurationcontainer">
			<p class="datasetheading"><?php esc_html_e( 'Configuration Area' , 'qc-opd' ); ?></p>

			<table id="configtable" class="configtable" cellspacing="0">
				<tr>
					<td><?php esc_html_e( 'Background Color' , 'qc-opd' ); ?></td>
					<td><input type="text" id="backgroundcolor" name="backgroundcolor" class="color-field" /></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'Border Color' , 'qc-opd' ); ?></td>
					<td><input type="text" id="bordercolor" name="bordercolor" class="color-field" /></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'Pointer Style' , 'qc-opd' ); ?></td>
					<td><select name="pointerstyle" id="pointerstyle">
						<option value="circle"><?php esc_html_e( 'circle' , 'qc-opd' ); ?></option>
						<option value="triangle"><?php esc_html_e( 'triangle' , 'qc-opd' ); ?></option>
						<option value="rect"><?php esc_html_e( 'rect' , 'qc-opd' ); ?></option>
						<option value="rectRounded"><?php esc_html_e( 'rectRounded' , 'qc-opd' ); ?></option>
						<option value="rectRot"><?php esc_html_e( 'rectRot' , 'qc-opd' ); ?></option>
						<option value="cross"><?php esc_html_e( 'cross' , 'qc-opd' ); ?></option>
						<option value="crossRot"><?php esc_html_e( 'crossRot' , 'qc-opd' ); ?></option>
						<option value="star"><?php esc_html_e( 'star' , 'qc-opd' ); ?></option>
						<option value="line"><?php esc_html_e( 'line' , 'qc-opd' ); ?></option>
						<option value="dash"><?php esc_html_e( 'dash' , 'qc-opd' ); ?></option>
					</select></td>
				</tr>
				<tr id="linestyle">
					<td><?php esc_html_e( 'Line Style' , 'qc-opd' ); ?></td>
					<td><select name="lstyle" id="lstyle">
						<option value=""><?php esc_html_e( 'Default' , 'qc-opd' ); ?></option>
						<option value="stepped"><?php esc_html_e( 'Stepped' , 'qc-opd' ); ?></option>
						<option value="filled"><?php esc_html_e( 'filled' , 'qc-opd' ); ?></option>
						<option value="dashed"><?php esc_html_e( 'Dashed' , 'qc-opd' ); ?></option>
					</select></td>
				</tr>		
				<tr id="linestyle">
					<td><?php esc_html_e( 'Tooltips' , 'qc-opd' ); ?></td>
					<td><select name="tooltips" id="tooltips">
						<option value=""><?php esc_html_e( 'Show' , 'qc-opd' ); ?></option>
						<option value="false"><?php esc_html_e( 'Hide' , 'qc-opd' ); ?></option>
					</select></td>
				</tr>		
				<tr id="linestyle">
					<td><?php esc_html_e( 'Y labels' , 'qc-opd' ); ?></td>
					<td><select name="hide_y_labels" id="hide_y_labels">
						<option value=""><?php esc_html_e( 'Show' , 'qc-opd' ); ?></option>
						<option value="false"><?php esc_html_e( 'Hide' , 'qc-opd' ); ?></option>
					</select></td>
				</tr>				
			</table>
			
		</div>		
		<input type="button" value="<?php esc_html_e( 'Generate Chart' , 'qc-opd' ); ?>" class="button button-primary button-large getallvalue" />

  </div>
</div>
<?php

}
add_action( 'admin_footer', 'qcilist_pro_modal_chart');

function qcilist_pro_modal_chart_tynimc() {

?>
<div class="ilist-chart-field-modal" id="ilist-chart-field-modal_tinymc" style="display:none">
  <div class="ilist-chart-field-modal-close">&times;</div>
  <h1 class="ilist-chart-field-modal-title"><?php esc_html_e( 'Create Chart' , 'qc-opd' ); ?></h1>
 <div style="position: absolute;right: 59px;">
<input type="button" value="<?php esc_html_e( 'Generate Chart' , 'qc-opd' ); ?>" class="button button-primary button-large tinymcgetallvalue" />
</div>
  <div class="ichart-field-modal-icons">

		<div class="form-group">
			<label for="charttype"><?php esc_html_e( 'Select Chart Type' , 'qc-opd' ); ?></label>

			<select id="charttype" class="form-control">
				<option value="line"><?php esc_html_e( 'Line' , 'qc-opd' ); ?></option>
				<option value="bar"><?php esc_html_e( 'Bar' , 'qc-opd' ); ?></option>
				<option value="radar"><?php esc_html_e( 'Radar' , 'qc-opd' ); ?></option>
				<option value="polarArea"><?php esc_html_e( 'Polar Area' , 'qc-opd' ); ?></option>
				<option value="pie"><?php esc_html_e( 'Pie' , 'qc-opd' ); ?></option>
				<option value="doughnut"><?php esc_html_e( 'Doughnut' , 'qc-opd' ); ?></option>
				
			</select>
		</div>
		<div class="form-group">
			<label for="datasettitle"><?php esc_html_e( 'Chart Title' , 'qc-opd' ); ?></label>
			<input type="text" id="charttitle" required/>
		</div>
		<div id="datasetcontainer" class="datasetcontainer">
			<p class="datasetheading"><?php esc_html_e( 'Dataset Area' , 'qc-opd' ); ?></p>
			<div class="form-group">
				<label for="datasettitle"><?php esc_html_e( 'Dataset Name' , 'qc-opd' ); ?></label>
				<input type="text" id="datasetname" required/>
			</div>
			<table id="datasettabletinymc" class="datasettable" cellspacing="0">
				<thead>
				<tr>
						<th class="manage-column column-cb check-column" scope="col"><?php esc_html_e( 'Label' , 'qc-opd' ); ?></th> 
						<th id="columnname" class="manage-column column-columnname" scope="col"><?php esc_html_e( 'Value' , 'qc-opd' ); ?></th>
						<th id="columnname" class="manage-column column-columnname" scope="col"><?php esc_html_e( 'Color' , 'qc-opd' ); ?></th>
				</tr>
				</thead>
				<tfoot>
					<tr>
						<th class="manage-column column-cb check-column" scope="col"><input type="button" id="chartaddrowtinymc" value="+ <?php esc_html_e( 'Add row' , 'qc-opd' ); ?>" class="button button-primary button-large" /></th>
						<th class="manage-column column-columnname" scope="col"></th>
					</tr>
				</tfoot>
				<tbody>
					<tr>
						<td class="check-column" scope="row"><input type="text" name="label[]" /></td>
						<td class="column-columnname"><input type="text" name="value[]" /></td>
						<td class="column-columnname"><input type="text" name="bgcolor[]" class="color-field" /></td>
						
						<td class="column-columnname"><a href="javascript:void(0);" class="removerow"><?php esc_html_e( 'Remove' , 'qc-opd' ); ?></a></td>
					</tr>
				</tbody>
			</table>
			
		</div>
		<div id="configurationcontainer" class="configurationcontainer">
			<p class="datasetheading"><?php esc_html_e( 'Configuration Area' , 'qc-opd' ); ?></p>

			<table id="configtable" class="configtable" cellspacing="0">
				<tr>
					<td><?php esc_html_e( 'Background Color' , 'qc-opd' ); ?></td>
					<td><input type="text" id="backgroundcolor" name="backgroundcolor" class="color-field" /></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'Border Color' , 'qc-opd' ); ?></td>
					<td><input type="text" id="bordercolor" name="bordercolor" class="color-field" /></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'Pointer Style' , 'qc-opd' ); ?></td>
					<td><select name="pointerstyle" id="pointerstyle">
						<option value="circle"><?php esc_html_e( 'circle' , 'qc-opd' ); ?></option>
						<option value="triangle"><?php esc_html_e( 'triangle' , 'qc-opd' ); ?></option>
						<option value="rect"><?php esc_html_e( 'rect' , 'qc-opd' ); ?></option>
						<option value="rectRounded"><?php esc_html_e( 'rectRounded' , 'qc-opd' ); ?></option>
						<option value="rectRot"><?php esc_html_e( 'rectRot' , 'qc-opd' ); ?></option>
						<option value="cross"><?php esc_html_e( 'cross' , 'qc-opd' ); ?></option>
						<option value="crossRot"><?php esc_html_e( 'crossRot' , 'qc-opd' ); ?></option>
						<option value="star"><?php esc_html_e( 'star' , 'qc-opd' ); ?></option>
						<option value="line"><?php esc_html_e( 'line' , 'qc-opd' ); ?></option>
						<option value="dash"><?php esc_html_e( 'dash' , 'qc-opd' ); ?></option>
					</select></td>
				</tr>
				<tr id="linestyle">
					<td><?php esc_html_e( 'Line Style' , 'qc-opd' ); ?></td>
					<td><select name="lstyle" id="lstyle">
						<option value=""><?php esc_html_e( 'Default' , 'qc-opd' ); ?></option>
						<option value="stepped"><?php esc_html_e( 'Stepped' , 'qc-opd' ); ?></option>
						<option value="filled"><?php esc_html_e( 'filled' , 'qc-opd' ); ?></option>
						<option value="dashed"><?php esc_html_e( 'Dashed' , 'qc-opd' ); ?></option>
					</select></td>
				</tr>		
				<tr id="linestyle">
					<td><?php esc_html_e( 'Tooltips' , 'qc-opd' ); ?></td>
					<td><select name="tooltips" id="tooltips">
						<option value=""><?php esc_html_e( 'Show' , 'qc-opd' ); ?></option>
						<option value="false"><?php esc_html_e( 'Hide' , 'qc-opd' ); ?></option>
					</select></td>
				</tr>		
				<tr id="linestyle">
					<td><?php esc_html_e( 'Y labels' , 'qc-opd' ); ?></td>
					<td><select name="hide_y_labels" id="hide_y_labels">
						<option value=""><?php esc_html_e( 'Show' , 'qc-opd' ); ?></option>
						<option value="false"><?php esc_html_e( 'Hide' , 'qc-opd' ); ?></option>
					</select></td>
				</tr>				
			</table>
			
		</div>		
		<input type="button" value="<?php esc_html_e( 'Generate Chart' , 'qc-opd' ); ?>" class="button button-primary button-large tinymcgetallvalue" />

  </div>
  <div class="ichart_shortcode_container" style="display:none;">
		<div class="qcpd_single_field_shortcode">
			<textarea style="width:100%;height:200px" id="ichart_shortcode_container"></textarea>
			<p><b><?php esc_html_e( 'Copy' , 'qc-opd' ); ?></b> <?php esc_html_e( 'the shortcode & use it any text block.' , 'qc-opd' ); ?> <button class="ichart_copy_close button button-primary button-small" style="float:right"> <?php esc_html_e( 'Copy & Close' , 'qc-opd' ); ?></button></p>
		</div>
	</div>
  
</div>
<?php
}

function qcilist_pro_sld_clean($string) {
   $string = str_replace(' ', '-', strtolower($string)); // Replaces all spaces with hyphens.
   return preg_replace('/[^A-Za-z0-9\-]/', '', $string); // Removes special chars.
}

add_action( 'admin_footer', 'qcilist_pro_modal_chart_tynimc');

add_shortcode('qcld-chart', 'qcilist_pro_textlist_full_shortcode_chart');
function qcilist_pro_textlist_full_shortcode_chart($atts = array()){
	wp_register_script( 'ilist-chart-js', QCOPD_ASSETS_URL1 . '/js/Chart.js', array('jquery'));
	wp_enqueue_script( 'ilist-chart-js');
	ob_start();
	extract( shortcode_atts(
		array(
			'label' 						=> 'january,February,March,April',
			'value' 						=> '80,-30,20,-50',
			'type' 							=> 'line',
			'title' 						=> 'Demo Title',
			'datasetname'				=>'Demo',
			'backgroundcolor' 	=> '',
			'bgcolor' 					=> '',
			'bordercolor' 			=> '',
			'pointerstyle' 			=> 'circle',
			'linestyle' 				=> "",
			'tooltips' 					=> 'index',
			'hide_y_labels' 		=> true
		), $atts
	));
	$label = explode(',',$label);
	$label = '"'.implode('","',$label).'"';
	
	$_ex = qcilist_pro_sld_clean($title);

	$tooltips = ( isset( $tooltips ) && !empty( $tooltips ) ) ? $tooltips : 'index';
	$hide_y_labels = ( isset( $hide_y_labels ) && !empty( $hide_y_labels ) ) ? $hide_y_labels : true;
	//$hide_y_labels = isset( $hide_y_labels ) ? 0 : 1;
	
?>
	<canvas id="myChart<?php echo $_ex; ?>"></canvas>


<script>
jQuery(document).ready(function($){

	var ctx = document.getElementById("myChart<?php echo $_ex; ?>");

	var myChart = new Chart(ctx, {
	    type: "<?php echo $type; ?>",
	    data: {
	        labels: [<?php echo $label; ?>],
	        datasets: [{
	            label: '<?php echo $datasetname ?>',
	            data: [<?php echo $value; ?>],
				<?php 
				if(strlen($bgcolor)>2 and $type!='line' and $type!='radar'){
				?>
				backgroundColor: [<?php echo $bgcolor ?>],
				<?php
				}else{
				?>
				backgroundColor: '<?php echo $backgroundcolor ?>',
				<?php
				}
				?>
				
	            <?php 
				if($bordercolor!=''){
				?>
				borderColor: '<?php echo $bordercolor ?>',
				<?php
				}
				?>
	            pointRadius: 8,
				pointHoverRadius: 11,
	            //borderWidth: 3,
				<?php 
				if($linestyle=='filled'){
				?>
				fill: true,
				<?php
				}elseif($linestyle=='stepped'){
				?>
				steppedLine: true,
				fill: false,
				<?php 
				}elseif($linestyle=='dashed'){
				?>
				borderDash: [5, 5],
				fill: false,
				<?php
				}else{
				?>
				fill: false,
				<?php
				}
				?>

				
	        }]
	    },
	    options: {
					elements: {
						point: {
							pointStyle: '<?php echo $pointerstyle ?>'
						}
					},
					title: {
            display: true,
              text: '<?php echo esc_attr($title); ?>'
          },
					tooltips: {
            mode: '<?php echo esc_attr($tooltips); ?>',
            intersect: true,
	        },
          hover: {
              mode: 'nearest',
              intersect: true
          },
					scale: {
          	ticks: {
              beginAtZero: true,
              display: <?php echo esc_attr($hide_y_labels); ?>,
            }
          }

	    }
	});

});
</script>
<?php
	$content = ob_get_clean();
    return $content;
}

add_action( 'admin_footer', 'qcilist_pro_modal_ajax_loading');
function qcilist_pro_modal_ajax_loading(){
?>
<div id="ajax-modal" class="ilistmodalajaxloading">
<div style="height: 100%;justify-content: center;display:flex"><img style="width: 87px;align-self: center;" src="<?php echo QCOPD_IMG_URL1.'/loadingajax.gif'; ?>" alt=""/></div>
</div>
<?php
}




